#include <Servo.h>
#include <LiquidCrystal.h>
//definicion de piens del lcd
#define rs 13
#define en 12
#define d4 11
#define d5 10
#define d6 9
#define d7 8

LiquidCrystal lcd(rs, en, d4, d5, d6, d7);

void LCD(String(msg), int(col) = 0, int(row) = 0) {
  lcd.setCursor(col, row);
  lcd.print(msg);
}


const int pingPin1 = 7;  // Trigger Pin of Ultrasonic Sensor
const int echoPin1 = 5;  // Echo Pin of Ultrasonic Sensor

const int pingPin2 = 4;  // Trigger Pin of Ultrasonic Sensor
const int echoPin2 = 3;  // Echo Pin of Ultrasonic Sensor

const int pingPin3 = A0;  // Trigger Pin of Ultrasonic Sensor
const int echoPin3 = A1;  // Echo Pin of Ultrasonic Sensor
                          ///////////////////ledSalidas
const int ledDiponibleVerde = A3;
const int ledDiponibleRojo = A2;
const int ledPaq1 = A4;
const int ledPaq2 = A5;

Servo puertaServo;  // Declarar un objeto de servo en la libreria


int servoAbierto = 90;  // Ángulo mínimo del servo (ajusta según tus necesidades apertura)
int servoCerrado = 0;   // Ángulo máximo del servo (ajusta según tus necesidades cerrado)

float minDistance = 40;   // Distancia mínima en centímetros 
float maxDistance = 150;  // Distancia máxima en centímetros

int Numparq = 2;       //variable almacenael nuemro de parqueaderos cojones o espacios
int NumparqOcupados = 0; //variable acomula el nuero de parquederos ocupados
boolean Paq1 = 0, Paq2 = 0; //estado de cada cajon
boolean Paq1Ant = 0, Paq2Ant = 0; //almacena el estado anteriro para comparra la variable actual
void setup() {
  puertaServo.attach(6);  // Asignar el servo al pin 6
  Serial.begin(9600);

//declaracion de salida pines de led 
  pinMode(ledDiponibleVerde, OUTPUT);
  pinMode(ledDiponibleRojo, OUTPUT);
  pinMode(ledPaq1, OUTPUT);
  pinMode(ledPaq2, OUTPUT);
  //inicializan apagados
  digitalWrite(ledDiponibleVerde, LOW);
  digitalWrite(ledDiponibleRojo, LOW);
  digitalWrite(ledPaq1, LOW);
  digitalWrite(ledPaq2, LOW);
//declaracion de modo de los pines de cada sensor  ultrazonido
  pinMode(pingPin1, OUTPUT);
  pinMode(echoPin1, INPUT);

  pinMode(pingPin2, OUTPUT);
  pinMode(echoPin2, INPUT);

  pinMode(pingPin3, OUTPUT);
  pinMode(echoPin3, INPUT);

  puertaServo.write(servoCerrado);
  lcd.begin(16, 2);
  LCD("UTL");
  LCD("TEST CODE", 0, 1);
  delay(200);
  lcd.clear();
  LCD("Bienvenido");
}

void loop() {
// Variables para calcular y almacenar la distancia en centímetros de cada sensor
long duration, cm1, cm2, cm3;

// Sensor ultrasónico 1
pinMode(pingPin1, OUTPUT);
digitalWrite(pingPin1, LOW);
delayMicroseconds(2);
digitalWrite(pingPin1, HIGH);
delayMicroseconds(10);
digitalWrite(pingPin1, LOW);

pinMode(echoPin1, INPUT);
duration = pulseIn(echoPin1, HIGH);
cm1 = (duration * 0.034 / 2);//esta es la medida el ultrzonico de entrada


// Sensor ultrasónico 2
pinMode(pingPin2, OUTPUT);
digitalWrite(pingPin2, LOW);
delayMicroseconds(2);
digitalWrite(pingPin2, HIGH);
delayMicroseconds(10);
digitalWrite(pingPin2, LOW);

pinMode(echoPin2, INPUT);
duration = pulseIn(echoPin2, HIGH);
cm2 = (duration * 0.034 / 2);

// Si la distancia medida por el sensor 2 es menor que la distancia mínima
if (cm2 < minDistance) {
  Paq1 = 1; // Espacio de estacionamiento 2 ocupado
  digitalWrite(ledPaq1, 0); // LED indicador del espacio 2 apagado
} else {
  Paq1 = 0; // Espacio de estacionamiento 2 disponible
  digitalWrite(ledPaq1, 1); // LED indicador del espacio 2 encendido
}

// Sensor ultrasónico 3
pinMode(pingPin3, OUTPUT);
digitalWrite(pingPin3, LOW);
delayMicroseconds(2);
digitalWrite(pingPin3, HIGH);
delayMicroseconds(10);
digitalWrite(pingPin3, LOW);

pinMode(echoPin3, INPUT);
duration = pulseIn(echoPin3, HIGH);
cm3 = (duration * 0.034 / 2);

// Si la distancia medida por el sensor 3 es menor que la distancia mínima
if (cm3 < minDistance) {
  Paq2 = 1; // Espacio de estacionamiento 3 ocupado
  digitalWrite(ledPaq2, 0); // LED indicador del espacio 3 apagado
} else {
  Paq2 = 0; // Espacio de estacionamiento 3 disponible
  digitalWrite(ledPaq2, 1); // LED indicador del espacio 3 encendido
}
if (cm1 < minDistance) {
  // Si un vehículo está detectado cerca del primer sensor ultrasónico
  lcd.clear(); // Borra la pantalla LCD
  LCD("Bienvenido"); // Muestra el mensaje de bienvenida en el LCD
  if (Numparq - NumparqOcupados > 0) {
    // Si hay espacios disponibles en el estacionamiento
    delay(200);
    LCD("ADELANTE", 0, 1); // Muestra "ADELANTE" en el LCD
    abrirPuerta(1800); // Abre la puerta por 800 milisegundos
    delay(200);
    lcd.clear(); // Borra la pantalla LCD
  } else {
    // Si no hay espacios disponibles en el estacionamiento
    delay(200);
    lcd.clear(); // Borra la pantalla LCD
    LCD("Lo sentimos"); // Muestra "Lo sentimos" en el LCD
    LCD("NO HAY ESPACIO ", 0, 1); // Muestra "NO HAY ESPACIO" en el LCD
    delay(800);
    lcd.clear(); // Borra la pantalla LCD después de 800 milisegundos
  }
} else {
  // Si no se detecta un vehículo cerca del primer sensor ultrasónico
  LCD("Parqueaderos disponibles:", 0, 0); // Muestra "Parqueaderos disponibles:" en el LCD
  LCD(String(Numparq - NumparqOcupados), 0, 1); // Muestra el número de espacios disponibles en el LCD
  if (Numparq - NumparqOcupados > 0) {
    // Si hay espacios disponibles en el estacionamiento
    digitalWrite(ledDiponibleVerde, 1); // Enciende el LED verde indicando espacios disponibles
    digitalWrite(ledDiponibleRojo, 0); // Apaga el LED rojo indicando que no hay espacios
  } else {
    // Si no hay espacios disponibles en el estacionamiento
    digitalWrite(ledDiponibleVerde, 0); // Apaga el LED verde
    digitalWrite(ledDiponibleRojo, 1); // Enciende el LED rojo indicando que no hay espacios
  }
}
  // Enviar datos por el puerto serial
  Serial.println("Distancia_Sen1: ");
  Serial.print(cm1);
  Serial.print("Distancia_Sen2: ");
  Serial.print(cm2);
  Serial.print("Distancia_Sen3: ");
  Serial.print(cm3);

// Verificar cambios en el estado de los espacios de estacionamiento 1 y 2
if (Paq1 != Paq1Ant) {
  // Si hay un cambio en el estado del espacio 1
  if (Paq1 == 1) {
    NumparqOcupados++; // Incrementar el número de espacios ocupados
  } else {
    NumparqOcupados--; // Decrementar el número de espacios ocupados
  }
  Paq1Ant = Paq1; // Actualizar el estado anterior del espacio 1
}

// Verificar cambios en el estado de los espacios de estacionamiento 2 y 3
if (Paq2 != Paq2Ant) {
  // Si hay un cambio en el estado del espacio 2
  if (Paq2 == 1) {
    NumparqOcupados++; // Incrementar el número de espacios ocupados
  } else {
    NumparqOcupados--; // Decrementar el número de espacios ocupados
  }
  Paq2Ant = Paq2; // Actualizar el estado anterior del espacio 2
}
}
void abrirPuerta(int mS) {
  puertaServo.write(servoAbierto);  // Mueve el servo a la posición de puerta abierta
  delay(mS);  // Espera un tiempo resibido en el parametro
  puertaServo.write(servoCerrado);  // Mueve el servo a la posición de puerta cerrada
}
